/*
angular.module('app')
.service('DataOld', function ($rootScope, $timeout, $http) {

  function getDateFromTable (date, time) {
      date = date.split('\.');
      date = moment(date[1] + '.' + date[0] + '.2017. ' + time);
      return date.format('YYYY-MM-DD HH:mm:ss');
  }

	var _this = this;

	var _scope = $rootScope.$new(true);
		_scope.hasCal = 0;
		_scope.news = [];
		_scope.schedule = [];
    	_scope.scheduleFormated = [];
        _scope.speakers = [];
		_scope.about = {};

	var _data = {};


    _scope.calendars = [{name: 'a'}, {name: 'a'}, {name: 'a'}, {name: 'a'}];

    function format(list) {

    	var l = [];
      var rooms = {};
      list.forEach(function (lecture) {
        if (!lecture.room) return;
        if (!rooms[lecture.room]) {
          rooms[lecture.room] = true;
        }
      });
      var uniqueRooms = [];
      angular.forEach(rooms, function (_, room) {
        uniqueRooms.push({
          name: room,
          id: null
        });
      });
      uniqueRooms = uniqueRooms.sort(function (a, b) {
        return a.name < b.name ? -1 : a.name > b.name ? 1 : 0;
      });
      rooms = {};
      uniqueRooms.forEach(function (room, index) {
        rooms[room.name] = index + 1;
      })
      // list.forEach(function (lecture) {
      //   if (!lecture.date) return;
      //   var d = new Date(lecture.date);
      //   // console.log(9, lecture.room ? rooms[lecture.room] : 0, d.getDate(), d.getHours(), d.getMinutes());
      //   lecture.id = parseInt([
      //     9,
      //     lecture.room ? rooms[lecture.room] : 0,
      //     (d.getDate() / 100).toFixed(2).slice(2),
      //     (d.getHours() / 100).toFixed(2).slice(2),
      //     (d.getMinutes() / 100).toFixed(2).slice(2)
      //   ].join(''));
      // });

    	function getLocationIndex(list, title) {
    		for (var i = 0; i < list.length; i++) {
    			if (title == list[i].title) {
    				return i;
    			}
    		}
    		return -1;
    	};

    	for (var i = 0; i < list.length; i++) {

    		//list[i].date = moment().add('minutes', 2).format("YYYY-MM-DD HH:mm:ss");

    		if (l.length == 0 || moment(list[i].date).isAfter(moment(l[l.length - 1].date), 'day')) {
    			l.push({
    				date: list[i].date,
    				locations: []
    			});
    		}

			var li = getLocationIndex(l[l.length - 1].locations, list[i].location);

			if (li < 0) {
				l[l.length - 1].locations.push({
					title: list[i].location,
					room: list[i].room,
					lectures: [
						list[i]
					]
				});
			} else {
				l[l.length - 1].locations[li].lectures.push(list[i]);
			}
    	}
console.log(l)

    	return l;
    };

    function sort(list) {
    	list.sort(function(a, b) {
            return moment(a.date).diff(moment(b.date));
        });
    	return list;
    };

    _scope.debug = ['init'];

    Object.defineProperties(this, {
        news: {
            get: function () {
                return _scope.news;
            },
            enumerable: true
        },
        speakers: {
            get: function () {
                return _scope.speakers;
            },
            enumerable: true
        },
        about: {
            get: function () {
                return _scope.about;
            },
            enumerable: true
        },
        schedule: {
        	get: function () {
        		return _scope.scheduleFormated;
        	},
        	enumerable: true
        },
        calendars: {
        	get: function () {
        		return _scope.calendars;
        	},
        	enumerable: true
        },
        debug: {
        	get: function () {
        		return _scope.debug;
        	},
        	enumerable: true
        },
        hasCal: {
        	get: function () {
        		return _scope.hasCal;
        	},
        	enumerable: true
        }
    });

    this.removeFromCalendar = function (data) {

    	var speaker = this.getSpeaker(data.lecture.speaker);

    	if (window.plugins && window.plugins.calendar) {
	    	window.plugins.calendar.deleteEvent(
				data.lecture.title,
	            data.lecture.location,
	            speaker ? ('Predavač: ' + speaker.name + ' ' + speaker.lastname) : '',
	            new Date(moment(data.lecture.date).format()),
	            data.lecture.end ? (new Date(moment(data.lecture.end).format())) : (new Date(moment(data.lecture.date).endOf('day').format())),
	            function (e) {
	            	data.lecture.inCal = 0;
	            	_scope.$apply(function () {
	            		data.lecture.inCal = 0;
	            	});
	            },
	            function (e) {
	            	data.lecture.inCal = 1;
	            	_scope.$apply(function () {
	            		data.lecture.inCal = 1;
	            	});
	            }
	    	);
	    }

    };

    this.addToCalendar = function (data) {

        var options;
        var speaker = this.getSpeaker(data.lecture.speaker);
        _scope.debug.push('addToCalendar');
        if (window.plugins && window.plugins.calendar) {
        	_scope.debug.push('has plugins');
        	options = window.plugins.calendar.getCalendarOptions();
            options.firstReminderMinutes = data.reminder;
	        window.plugins.calendar.createEventWithOptions(
	            data.lecture.title,
	            data.lecture.location,
	            speaker ? ('Predavač: ' + speaker.name + ' ' + speaker.lastname) : '',
	            new Date(moment(data.lecture.date).format()),
	            data.lecture.end ? (new Date(moment(data.lecture.end).format())) : (new Date(moment(data.lecture.date).endOf('day').format())),
	            options,
	            function (e) {
	            	_scope.debug.push('success');
	            	data.lecture.inCal = 1;
	            	_scope.$apply(function () {
	            		_scope.debug.push('apply success');
	            		data.lecture.inCal = 1;
	            	});
	            },
	            function (e) {
	            	_scope.debug.push('fail');
	            	data.lecture.inCal = 0;
	            	_scope.$apply(function () {
	            		_scope.debug.push('apply fail');
	            		data.lecture.inCal = 0;
	            	});
	            }
	        );
		}
    };

    this.getSpeaker = function(id) {
    	if (!_scope.speakers) {
    		return null;
    	}
    	for (var i = 0; i < _scope.speakers.length; i++) {
    		if (id == _scope.speakers[i].id) {
    			return _scope.speakers[i];
    		}
    	}
    	return null;
    };

    this.getScheduleBySpeaker = function(id) {
    	var list = [];
    	for (var i = 0; i < _data.schedule.length; i++) {
    		if (id == _data.schedule[i].speaker || (_data.schedule[i].speakers && _data.schedule[i].speakers.indexOf(id) >= 0)) {
    			list.push(_data.schedule[i]);
    		}
    	}
    	return list;
    };

    // var dataLocation = 'http://192.168.178.23/pepa/dani_komunikacija_2015/';
    var dataLocation = 'http://apps.devel.burza.hr/dani-komunikacija/';
    // var dataLocation = 'http://users.web/pepa/dani_komunikacija_2015/';
    // var dataLocation = 'http://apps.devel.burza.hr/dani_komunikacija/';
    var dataDirectory = (window.cordova && window.cordova.file && window.cordova.file.dataDirectory) || '';

    var checkFile = function (data, param) {

        data[param + 'Loaded'] = dataDirectory + data[param];
        return;

        try {
            window.resolveLocalFileSystemURL(dataDirectory + data[param], setFile(data, param), getFile(data, param));
        } catch (e) {
            setFile(data, param)();
        }

    };

    var setFile = function (data, param) {
        return function () {
            data[param + 'Loaded'] = dataDirectory + data[param];
        };
    };

    var getFile = function (data, param) {

        return function () {
            var fileTransfer = new FileTransfer();
                fileTransfer.download(dataLocation + data[param], dataDirectory + data[param], setFile(data, param), function () {
                    // error
                });
        };

    };

	var updateData = function (data, save) {

        _data.about = data.about;

		_data.speakers = data.speakers.sort(function(a, b) {
			return a.index - b.index;
		});

		_data.schedule = data.schedule;

		_data.news = Object.keys(data.news).map(function (index) {
			return data.news[index];
		}).filter(function (item) {
			return angular.isObject(item);
		}).map(function (item) {
			return {
				date: item.created_at,
				title: linkify_entities(item)
			};
		});

		if (save) {
			localStorage['data'] = JSON.stringify(_data);
		}

        fillData();

	};

    var fillData = function () {

		$timeout(function () {

            angular.extend(_scope.about, _data.about);

			while (_scope.speakers.length) _scope.speakers.pop();
			angular.extend(_scope.speakers, _data.speakers);

			while (_scope.scheduleFormated.length) _scope.scheduleFormated.pop();
			angular.extend(_scope.scheduleFormated, format(_data.schedule));

			while (_scope.news.length) _scope.news.pop();
			angular.extend(_scope.news, _data.news);

            angular.forEach(_scope.speakers, function (speaker) {
                checkFile(speaker.image, 'thumb');
                checkFile(speaker.image, 'large');
            });

            checkCal();

        });

    };

    if (localStorage && localStorage['data']) {
    	_data = JSON.parse(localStorage['data']);
        fillData();
        // updateData(JSON.parse(localStorage['data']));
    }

    var loadData = function () {
		$http.get(dataLocation + 'data.php').success(function(response) {
			if (response) {
        updateData(response, true);
        });
			}
		});
	};

	loadData();

});
*/
function escapeHTML(text) {
  return angular.element('<div/>').text(text || '').html();
}

function linkify_entities(tweet) {
  if (!(tweet.entities)) {
    return escapeHTML(tweet.text);
  }

  // This is very naive, should find a better way to parse this
  var index_map = {}

  angular.forEach(tweet.entities.urls, function (entry, i) {
    index_map[entry.indices[0]] = [entry.indices[1], function (text) { return '<a ng-click="open(\'' + escapeHTML(entry.url) + '\')">' + escapeHTML(entry.display_url) + '</a>' }]
  })

  angular.forEach(tweet.entities.hashtags, function (entry, i) {
    index_map[entry.indices[0]] = [entry.indices[1], function (text) { return '<a ng-click="open(\'http://twitter.com/search?q=' + escape("#" + entry.text) + '\')">' + escapeHTML(text) + '</a>' }]
  })

  angular.forEach(tweet.entities.user_mentions, function (entry, i) {
    index_map[entry.indices[0]] = [entry.indices[1], function (text) { return '<a title="' + escapeHTML(entry.name) + '" ng-click="open(\'http://twitter.com/' + escapeHTML(entry.screen_name) + '\')">' + escapeHTML(text) + '</a>' }]
  })

  var result = ""
  var last_i = 0
  var i = 0

  // iterate through the string looking for matches in the index_map
  for (i = 0; i < tweet.text.length; ++i) {
    var ind = index_map[i]
    if (ind) {
      var end = ind[0]
      var func = ind[1]
      if (i > last_i) {
        result += (tweet.text.substring(last_i, i))
      }
      result += func(tweet.text.substring(i, end))
      i = end - 1
      last_i = end
    }
  }

  if (i > last_i) {
    result += (tweet.text.substring(last_i, i))
  }

  return result
}

angular.module('app')

  .service('Data', function ($rootScope, $timeout, $http, $q, $ionicPopup, $ionicPlatform, $cordovaLocalNotification) {

    var _this = this;

    var _scope = $rootScope.$new(true);

    var _data = {};
    var _dataLoader;

    var _dataLocation = 'http://apps.devel.burza.hr/dani-komunikacija/app/data.php';
    // var _dataLocation = 'http://localhost/dk_extra/data.php';
    // var _dataLocation = 'js/data.json';
    _dataLocation = 'http://dk-server.preview.burza.hr/api/events/feed';
    // _dataLocation = 'http://localhost:1347/api/events/feed';

    _scope.favoriteIds = [];

    var updateData = function (data, save) {

      _data = data;

      _data.updatedAt = Date.now();

      _data.formated = [];

      // _data.schedule.forEach(function (item) {
      //   item.event.start = moment(item.event.start).subtract(5, 'days').toDate();
      //   item.event.end = moment(item.event.end).subtract(5, 'days').toDate();
      // });

      _data.schedule.forEach(function (item) {

        var m = moment(item.event.start).subtract(6, 'h');
        var d = _data.formated.filter(function (day) {
          return m.isSame(moment(day.date), 'day');
        }).pop();
        if (!d) {
          d = {
            date: item.event.start,
            locations: [],
            lectures: []
          }
          _data.formated.push(d);
        }
        var l = d.locations.filter(function (location) {
          return item.event.room == location.title;
        }).pop();
        if (!l) {
          l = {
            title: item.event.room,
            lectures: []
          }
          d.locations.push(l);
        }
        l.lectures.push(item);
        d.lectures.push(item);

        item.favorite = _scope.isFavorite(item);

        if (!item.photo) return;
        // item.image = _data.about.image.folder + item.photo + '.' + _data.about.image.extension;
        item.image = item.photo;
      });
      var foundNextItem = false;
      _data.formated.forEach(function (day) {
        day.lectures = day.lectures.sort(function (a, b) {
          return a.event.start - b.event.start;
        });
        day.lectures.forEach(function (item) {
          if (!foundNextItem && moment(item.event.start).isAfter(moment(), 'm')) {
            foundNextItem = true;
            item.isNext = true;
          }
        });
      });
      _data.formated.sort(function (a, b) {
        return a.date - b.date;
      });
      // test
      // _data.formated[0].lectures.forEach(function (item, index) {
      //   var offset = 60 * (1 + index);
      //   item.event.title = (offset / 60) + 'min';
      //   item.event.start = +moment(Date.now() + offset * 1000).startOf('minute');
      // });

      _data.news = Object.keys(_data.news).map(function (index) {
        return data.news[index];
      }).filter(function (item) {
        return angular.isObject(item);
      }).map(function (item) {
        return {
          date: item.created_at,
          title: linkify_entities(item)
        };
      }).filter(function (item) {
        if (!_data.about || !_data.about.news || !_data.about.news.yearFilter) return true;
        return item.date.indexOf(_data.about.news.yearFilter) >= 0;
      });

      if (save) {
        localStorage['data'] = JSON.stringify(_data);
      }

      fillData();

    };

    var fillData = function () {

      $timeout(function () {
        angular.extend(_scope, _data);
      });

    };

    if (localStorage && localStorage['favorite']) {
      try {
        _scope.favoriteIds = JSON.parse(localStorage['favorite']);
      } catch (e) { }
    }

    if (localStorage && localStorage['data']) {
      try {
        _data = JSON.parse(localStorage['data']);
        fillData(_data);
      } catch (e) { }
    }

    var loadData = function () {
      _dataLoader = $http.get(_dataLocation).success(function (response) {
        // _dataLoader = $http.get('js/schedule.json').success(function (r) {
          if (response) {
            var diff;
            response.schedule.forEach(function (item, index) {
              if (!diff) {
                var yd = new Date(Date.now() - 24 * 60 * 60 * 1000);
                var d = new Date(item.event.start);
                    d.setDate(yd.getDate());
                    d.setMonth(yd.getMonth());
                    d.setFullYear(yd.getFullYear());
                diff = d.getTime() - new Date(item.event.start).getTime();
              }
              // item.event.start = new Date(new Date(item.event.start).getTime() + diff).getTime();
              // item.event.end = new Date(new Date(item.event.end).getTime() + diff).getTime();
              // item.event.start = new Date().getTime() - 5 * 60 * 1000 + index * 60 * 1000;
              // item.event.end = new Date().getTime() - 5 * 60 * 1000 + index * 60 * 1000 + 30 * 60 * 1000;
            });
            // response.schedule = r;
            updateData(response, true);
          }
        // });
      });
    };

    loadData();

    _scope.getById = function (id) {
      var deferred = $q.defer();
      function filter() {
        var item = _data.schedule.filter(function (item) {
          return item.id == id;
        });
        deferred.resolve(item.length ? item.pop() : null);
      }
      if (angular.isArray(_data.schedule)) {
        filter();
      } else {
        _dataLoader.then(filter);
      }
      return deferred.promise;
    };

    _scope.saveFavoriteIds = function () {
      _scope.favoriteIds = _data.schedule.filter(function (item) {
        return item.favorite;
      }).map(function (item) {
        return item.id;
      });
      localStorage['favorite'] = JSON.stringify(_scope.favoriteIds);
    };

    _scope.isFavorite = function (item) {
      return !!_scope.favoriteIds.filter(function (id) {
        return item.id == id;
      }).length;
    };

    _scope.toggleFavorite = function (item) {
      if (!item.favorite) {
        item.favorite = true;
        _scope.scheduleDelayedPushNotification(item);
        _scope.saveFavoriteIds();
      } else {
        $ionicPopup.confirm({
          subTitle: item.event.title,
          title: 'Ukloni iz favorita?',
          cancelText: 'Odustani',
          okText: 'Ukloni!'
        }).then(function(res) {
          if(res) {
            item.favorite = false;
            _scope.cancelDelayedPushNotification(item);
            _scope.saveFavoriteIds();
            console.log('You are sure');
          } else {
            console.log('You are not sure');
          }
        });
      }
    };

    _scope.scheduleDelayedPushNotification = function (item) {};
    _scope.cancelDelayedPushNotification = function () {};
    // _scope.qq = [
    //   new Date()
    // ];
    $ionicPlatform.ready(function () {

      if (!window.cordova) return;

      _scope.scheduleDelayedPushNotification = function (item) {
        var now = new Date().getTime();
        var at = new Date(item.event.start).getTime();
        var offset = 30 * 60 * 1000;
        // offset = 0;
        // _scope.qq.push(
        //   new Date()
        // );
        if (at <= (now + offset)) {
          return;
        }
        // _scope.qq.push(new Date(at - offset));
        $cordovaLocalNotification.schedule({
          id: item.id,
          title: (item.event.place || item.event.room) + ', za 30min: ' + (item.speaker.visible ? item.speaker.name : ''),
          text: item.event.title,
          trigger: {
            at: new Date(at - offset)
          },
          priority: 2,
          foreground: true
        }).then(function (result) {

        }, function (err) {

        });
      };
      _scope.cancelDelayedPushNotification = function (item) {
        $cordovaLocalNotification.cancel(item.id).then(function (result) {

        }, function (err) {

        });
      };

    });

    _scope.reload = function () {
      if (_data && _data.updatedAt) {
        if (_data.updatedAt < (Date.now() - 10 * 60 * 1000)) {
          loadData();
        }
      }
    };

    return _scope;

  });
